> ## Documentation Index
> Fetch the complete documentation index at: https://docs.p2p.org/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Block Rewards

> Method to retrieve Solana block rewards (block production fees and voting rewards) by block date.



## OpenAPI

````yaml openapi/data-api.json GET /api/v1/{network}/data/network/block/rewards
openapi: 3.0.0
info:
  title: Data API
  description: Network, validator, delegator, and delegator-pool analytics endpoints
  version: 1.0.0
  contact: {}
servers:
  - url: https://api.p2p.org/api
security:
  - bearer: []
tags:
  - name: Delegator
    description: Delegator analytics — rewards, APY, stakes, and summary data.
  - name: Network
    description: Network analytics — stake, rewards, APY, validators count.
  - name: Validator
    description: Validator analytics — summary, stakes, rewards, APY, fee, statuses.
paths:
  /api/v1/{network}/data/network/block/rewards:
    get:
      tags:
        - Network
      summary: Get Block Rewards
      description: >-
        Method to retrieve Solana block rewards (block production fees and
        voting rewards) by block date.
      operationId: data-network-block-rewards
      parameters:
        - name: network
          required: true
          in: path
          description: Network name.
          schema:
            enum:
              - solana
            type: string
        - name: startAt
          required: false
          in: query
          description: >-
            Timestamp of the report data period start in the ISO 8601 format. If
            not specified, the default value is the one month ago.
          schema:
            format: date-time
            example: '2024-01-01T00:00:00.000Z'
            type: string
        - name: finishAt
          required: false
          in: query
          description: >-
            Timestamp of the report data period finish in the ISO 8601 format.
            If not specified, the default value is the current date.
          schema:
            format: date-time
            example: '2024-01-01T00:00:00.000Z'
            type: string
        - name: startNumber
          required: false
          in: query
          description: Start number of the staking period.
          schema:
            format: int64
            type: integer
        - name: finishNumber
          required: false
          in: query
          description: Finish number of the staking period.
          schema:
            format: int64
            type: integer
        - name: limit
          required: false
          in: query
          description: Number of resources that a single response page contains.
          schema:
            minimum: 1
            maximum: 1000
            format: int32
            example: 50
            type: integer
        - name: offset
          required: false
          in: query
          description: Number of resources to exclude from a response.
          schema:
            minimum: 0
            maximum: 10000000
            format: int32
            example: 0
            type: integer
        - name: address
          required: true
          in: query
          description: Address of the block rewards in the required network.
          schema:
            type: string
        - name: rewardType
          required: false
          in: query
          description: >-
            Type of the block rewards to filter by. If not specified, rewards of
            every type are returned.
          schema:
            type: string
            enum:
              - Fee
              - Voting
              - Staking
              - DeactivatedStake
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/SuccessResponse'
                  - type: object
                    properties:
                      result:
                        $ref: >-
                          #/components/schemas/GetNetworkBlockRewardsListResponse
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/ExceptionResponse'
                  - type: object
                    properties:
                      error:
                        oneOf:
                          - $ref: '#/components/schemas/CommonValidationException'
                          - $ref: >-
                              #/components/schemas/DataNetworkIsNotIncludedInListException
              examples:
                ValidationException:
                  value:
                    error:
                      code: 100101
                      message: >-
                        The data provided is not valid. Please check the request
                        parameters and try again.
                      name: ValidationException
                      type: client
                    result: null
                DataNetworkIsNotIncludedInListException:
                  value:
                    error:
                      code: 100101
                      message: >-
                        The request could not be performed because the network
                        provided is not supported. undefined
                      name: DataNetworkIsNotIncludedInListException
                      type: client
                    result: null
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/ExceptionResponse'
                  - type: object
                    properties:
                      error:
                        oneOf:
                          - $ref: '#/components/schemas/AuthNoTokenException'
                          - $ref: '#/components/schemas/AuthWrongTokenException'
              examples:
                NoTokenException:
                  value:
                    error:
                      code: 101111
                      message: >-
                        No Bearer token has been provided. To obtain an
                        authentication token, follow the instructions at
                        https://docs.p2p.org/docs/authentication.
                      name: NoTokenException
                      type: authentication
                    result: null
                WrongTokenException:
                  value:
                    error:
                      code: 101109
                      message: >-
                        An invalid Bearer token has been provided. Please
                        specify the correct authentication token.
                      name: WrongTokenException
                      type: authentication
                    result: null
        '404':
          description: Not found
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/ExceptionResponse'
                  - type: object
                    properties:
                      error:
                        oneOf: []
              examples: {}
        '429':
          $ref: '#/components/responses/TooManyRequests'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/ExceptionResponse'
                  - type: object
                    properties:
                      error:
                        $ref: '#/components/schemas/GetNetworkBlockRewardsException'
              examples:
                GetNetworkBlockRewardsException:
                  value:
                    error:
                      code: 115210
                      message: >-
                        The list of network block rewards could not be obtained
                        because an internal server error occurred.
                      name: GetNetworkBlockRewardsException
                      type: server
                    result: null
      security:
        - bearer: []
components:
  schemas:
    SuccessResponse:
      type: object
      properties:
        error:
          type: object
          nullable: true
          default: null
          description: Error object. Always null on successful responses.
        result:
          type: object
          description: Response payload containing the requested data.
      description: Standard API success response envelope wrapping the result payload.
      required:
        - error
        - result
    GetNetworkBlockRewardsListResponse:
      type: object
      properties:
        limit:
          type: integer
          format: int32
          minimum: 1
          default: 50
          example: 50
          description: Number of resources that a single response page contains.
        offset:
          type: integer
          format: int32
          minimum: 0
          example: 0
          description: Number of resources to exclude from a response.
        startAt:
          type: string
          format: date-time
          description: Start of the requested data period.
        finishAt:
          type: string
          format: date-time
          description: End of the requested data period.
        list:
          description: List of network block reward records.
          type: array
          items:
            $ref: '#/components/schemas/GetNetworkBlockRewardsResponse'
      required:
        - limit
        - offset
        - startAt
        - finishAt
        - list
    ExceptionResponse:
      type: object
      properties:
        error:
          type: object
          description: Error object containing exception details. Null on success.
        result:
          type: object
          nullable: true
          default: null
          description: Result payload. Always null on error responses.
        requestId:
          type: string
          description: >-
            Identifier of the request (the `x-request-id` header). Quote this
            value to correlate the response with server logs.
          example: 90c16e9e-6e99-4651-a033-60290356df2f
        timestamp:
          type: string
          format: date-time
          description: ISO 8601 timestamp of when the error response was generated.
          example: '2026-05-20T22:29:03.126Z'
      description: Standard API error response envelope wrapping the exception details.
      required:
        - error
        - result
        - timestamp
    CommonValidationException:
      type: object
      properties:
        type:
          type: string
          default: client
          example: client
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 100101
          example: 100101
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: >-
            The data provided is not valid. Please check the request parameters
            and try again.
          example: >-
            The data provided is not valid. Please check the request parameters
            and try again.
          description: Human-readable error message describing what went wrong.
        errors:
          description: Validation error details when applicable.
          type: array
          items:
            $ref: '#/components/schemas/ValidationErrorResponse'
        name:
          type: string
          default: ValidationException
          example: ValidationException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - errors
        - name
    DataNetworkIsNotIncludedInListException:
      type: object
      properties:
        type:
          type: string
          default: client
          example: client
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 115101
          example: 115101
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: >-
            The request could not be performed because the network provided is
            not supported. solana, ethereum, polkadot, kusama, cosmoshub,
            polygon, sui, ton, cardano, tonwhales, celestia
          example: >-
            The request could not be performed because the network provided is
            not supported. solana, ethereum, polkadot, kusama, cosmoshub,
            polygon, sui, ton, cardano, tonwhales, celestia
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: DataNetworkIsNotIncludedInListException
          example: DataNetworkIsNotIncludedInListException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    AuthNoTokenException:
      type: object
      properties:
        type:
          type: string
          default: authentication
          example: authentication
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 101111
          example: 101111
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: >-
            No Bearer token has been provided. To obtain an authentication
            token, follow the instructions at
            https://docs.p2p.org/docs/authentication.
          example: >-
            No Bearer token has been provided. To obtain an authentication
            token, follow the instructions at
            https://docs.p2p.org/docs/authentication.
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: NoTokenException
          example: NoTokenException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    AuthWrongTokenException:
      type: object
      properties:
        type:
          type: string
          default: authentication
          example: authentication
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 101109
          example: 101109
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: >-
            An invalid Bearer token has been provided. Please specify the
            correct authentication token.
          example: >-
            An invalid Bearer token has been provided. Please specify the
            correct authentication token.
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: WrongTokenException
          example: WrongTokenException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    GetNetworkBlockRewardsException:
      type: object
      properties:
        type:
          type: string
          default: server
          example: server
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 115210
          example: 115210
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: >-
            The list of network block rewards could not be obtained because an
            internal server error occurred.
          example: >-
            The list of network block rewards could not be obtained because an
            internal server error occurred.
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: GetNetworkBlockRewardsException
          example: GetNetworkBlockRewardsException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    GetNetworkBlockRewardsResponse:
      type: object
      properties:
        stakingPeriodNumber:
          type: integer
          format: int32
          description: Unique identifier for the current staking period.
          example: 1227
        blockDate:
          format: date-time
          type: string
          description: Timestamp of the block date in the ISO 8601 format.
          example: '2023-08-24T08:23:18.830Z'
        blockDateTime:
          format: date-time
          type: string
          description: Timestamp of the block production in the ISO 8601 format (UTC).
          example: '2026-08-13T00:09:31.000Z'
        recipient:
          type: string
          description: Recipient address of the block reward
          example: 7EcDhSYGxXyscszYEp35KHN8vvw3svAuLKTzXwCFLtV
        rewardType:
          type: string
          description: Type of the block reward.
          enum:
            - Fee
            - Voting
            - Staking
            - DeactivatedStake
          example: Fee
        amount:
          type: number
          format: double
          description: Amount of the block reward
          example: 665113860
        processingDateTime:
          format: date-time
          type: string
          description: >-
            Timestamp of the moment the record was processed into the data
            warehouse, in the ISO 8601 format (UTC).
          example: '2026-08-13T02:19:59.426Z'
      required:
        - stakingPeriodNumber
        - blockDate
        - blockDateTime
        - recipient
        - rewardType
        - amount
        - processingDateTime
    ValidationErrorResponse:
      type: object
      properties:
        property:
          type: string
          description: Name of the property that failed validation.
        constraints:
          type: object
          additionalProperties:
            type: string
          description: Validation constraint details describing what was expected.
      required:
        - property
        - constraints
  responses:
    TooManyRequests:
      description: >-
        Too Many Requests — the client exceeded its rate limit. The response
        advertises when to retry and the active quota via headers.
      headers:
        Retry-After:
          description: Number of seconds to wait before retrying the request.
          schema:
            type: integer
            example: 60
        RateLimit-Limit:
          description: >-
            The request quota (maximum number of requests) for the most
            restrictive applicable window.
          schema:
            type: integer
            example: 120
        RateLimit-Reset:
          description: >-
            Number of seconds until the rate-limit window resets and requests
            are accepted again.
          schema:
            type: integer
            example: 60
        RateLimit-Policy:
          description: >-
            The active rate-limit policy as `<limit>;w=<window-seconds>`,
            comma-separated when multiple windows apply.
          schema:
            type: string
            example: 120;w=60
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: integer
                  name:
                    type: string
                    example: ThrottlerException
                  message:
                    type: string
                    example: ThrottlerException
                  errors:
                    type: array
                    nullable: true
                    items:
                      type: object
              result:
                type: object
                nullable: true
                example: null
              requestId:
                type: string
                description: >-
                  Identifier of the request (the `x-request-id` header). Quote
                  this value to correlate the response with server logs.
                example: 90c16e9e-6e99-4651-a033-60290356df2f
              timestamp:
                type: string
                format: date-time
                description: ISO 8601 timestamp of when the error response was generated.
                example: '2026-05-20T22:29:03.126Z'
  securitySchemes:
    bearer:
      scheme: bearer
      bearerFormat: JWT
      type: http

````

## Related topics

- [Get Validator Rewards](/reference/data-validator-rewards.md)
- [Get Delegator Rewards](/reference/data-delegator-rewards.md)
- [Get User Rewards](/reference/get-rewards.md)
- [Get Network Rewards](/reference/data-network-rewards.md)
- [Get Rewards History](/reference/eth-pool-account-rewards.md)
